#include "Tree.h"

//Show content of the node
void visit(NodePointer nodePointer)
{
    //printf("\n\t---Nó atual---\n");
    printf("Chave:%d\n", nodePointer->data.key);
    //printf("Nome:%s\n", nodePointer->data.name);
    printf("Valor:%f\n", nodePointer->data.value);
}

//https://www.geeksforgeeks.org/print-binary-tree-2-dimensions/
// Function to print binary tree in 2D
// It does reverse inorder traversal
void print2DUtil(NodePointer root, int space)
{
    // Base case
    if (root == NULL)
        return;

    // Increase distance between levels
    space += COUNT;

    // Process right child first
    print2DUtil(root->leftChild, space);

    // Print current node after space
    // count
    printf("\n");
    for (int i = COUNT; i < space; i++)
        printf(" ");
    printf("Chave:%d\n", root->data.key);
    /*for (int i = COUNT; i < space; i++)
        printf(" ");
    printf("Nome:%s\n", root->data.name);*/
    for (int i = COUNT; i < space; i++)
        printf(" ");
    printf("Valor:%f\n", root->data.value);

    // Process left child
    print2DUtil(root->rightChild, space);
}

// Wrapper over print2DUtil()
void print2D(NodePointer root)
{
   // Pass initial space count as 0
   print2DUtil(root, 0);
}

//Insert a node in the first available node
//Follows the rule that a node on the left is always smaller in value
//And one on the right is always greater.
void insert(NodePointer *node, DataStruct data)
{
    if(*node == NULL){
        *node = (TreeNode*) malloc(sizeof(TreeNode));
        (*node)->leftChild = NULL;
        (*node)->rightChild = NULL;
        (*node)->data = data;
    }
    else
    {
        if(data.value <(*node)->data.value)
             insert(&(*node)->leftChild, data);
        else
             insert(&(*node)->rightChild, data);
    }
}

//In order visit
void inOrder(NodePointer nodePointer) {
    if(nodePointer != NULL) {
        inOrder(nodePointer->leftChild);
        visit(nodePointer);
        inOrder(nodePointer->rightChild);
    }
}

//Pre order visit
void preOrder(NodePointer nodePointer){
     if(nodePointer != NULL){
         visit(nodePointer);
         preOrder(nodePointer->leftChild);
         preOrder(nodePointer->rightChild);
     }
 }

//Post order visit
void postOrder(NodePointer nodePointer){
    if(nodePointer != NULL){
        postOrder(nodePointer->leftChild);
        postOrder(nodePointer->rightChild);
        visit(nodePointer);
    }
}
